


OGONKIFY(1)               User Commands               OGONKIFY(1)



NAME
     ogonkify - change the encoding of the PostScript  output  of
     Netscape


SYNOPSIS
     ogonkify [-p procset] [-e encoding] [-r Old=New] [-a] [-c] [
     -t] [-at] [-ct] [-A] [-C] [-T] [-AT] [-CT] [-N] [-M] [-mp] [
     --] file ...


DESCRIPTION
     ogonkify does various munging of PostScript files related to
     printing  in different languages.  Its main use is to filter
     the output of Netscape or Mosaic in order  to  print  in  an
     Eastern-European language (e.g. Polish).


SUMMARY USAGE
     Installation instructions are provided in the file  INSTALL.
     Assuming the installation has been correctly completed, save
     the PostScript output of Netscape or Mosaic to a  file,  say
     output.ps.  Then print it using

          % ogonkify -AT -N output.ps | lpr

     in the case of Netscape, or

          % ogonkify -AT -M output.ps | lpr

     in the case of Mosaic.

     You may want to change the -AT option to -CT in order to use
     a high quality Courier font from IBM (at the price of slower
     printing).

     An alternative way to print from  Netscape  is  to  set  the
     printing command in the printing dialog box to:

          ogonkify -AT -N | lpr

     For more details, see the USAGE section below.


OPTIONS
     -p    Includes the specified procset in the output file.


     -e    Set  the  encoding  of  the  output.  Defaults  to  L2
          (ISO8859 -2, a.k.a. ISO Latin-2). Other possible values
          are L1 (ISO8859-1, a.k.a. ISO Latin-1), L3 (ISO8859- 3,
          a.k.a.  ISO  Latin-3), L4 (ISO8859-4, a.k.a. ISO Latin-



McKornik Jr.        Last change: 19 Feb 1997                    1






OGONKIFY(1)               User Commands               OGONKIFY(1)



          4), L5 (ISO8859-9, a.k.a. ISO Latin-5), L6 (ISO8859-10,
          a.k.a.  ISO Latin-6), CP1250 (Microsoft Code Page 1250,
          a.k.a. CeP),  ibmpc  (Original  IBM-PC  encoding),  mac
          (Apple Macintosh encoding) and hp (HP Roman Encoding).


     -r    Use the font New in place of Old.  Will lead  to  ugly
          or unreadable output when the metrics mismatch.


     -a    Do the right font remappings for using Courier- Ogonki
          in  place  of Courier (the a stands for Adobe Courier).
          This avoids downloading any fonts to the  printer.   It
          is equivalent to


          -r Courier=Courier-Ogonki
          -r Courier-Bold=Courier-Bold-Ogonki
          -r Courier-Oblique=Courier-Oblique-Ogonki
          -r Courier-BoldOblique=Courier-BoldOblique-Ogonki


     -c    Do the right font remappings for using IBM Courier  in
          place of Adobe Courier. It is equivalent to

          -r Courier-Oblique=Courier-Italic
          -r Courier-BoldOblique=Courier-BoldItalic


     -t    Do the right font remappings for using Times - Roman -
          Ogonki in place of Times-Roman. It is equivalent to


          -r Times-Roman=Times-Roman-Ogonki
          -r Times-Bold=Times-Bold-Ogonki
          -r Times-Italic=Times-Italic-Ogonki
          -r Times-BoldItalic=Times-BoldItalic-Ogonki


     -ct   Equivalent to -c -t.


     -A    Like -a but also downloads the Courier-Ogonki fonts.


     -C    Like -c, but also downloads the IBM Courier fonts.


     -T    Like -t, but also downloads  the  Times - xxx - Ogonki
          fonts.





McKornik Jr.        Last change: 19 Feb 1997                    2






OGONKIFY(1)               User Commands               OGONKIFY(1)



     -CT   Equivalent to -C -T.


     -N    Do Netscape processing.


     -M    Do Mosaic processing.


     -mp   Do mp processing.  Will not work with  the  -A  option
          (use -C instead).


     --     End options.



USAGE
     Let us assume that you want to print a WWW page  encoded  in
     ISO  Latin -2. Netscape stubbornly insists on printing it as
     ISO Latin-1. By using the File->Print command, have Netscape
     send the output to a file, say alamakota.ps.

     As ogonkify is configured for ISO Latin-2 by default,  pass-
     ing it the PostScript generated by Netscape will correct the
     encoding of the fonts. It is enough to do:

          % ogonkify -N <alamakota.ps | lpr

     However, most printers do not have  fonts  with  the  needed
     characters  installed;  synthetized fonts will be downloaded
     and used instead of Courier and Times-Roman with -AT, and  a
     very  good  Courier  font  from IBM will be used with:  -CT.
     The command will therefore typically be:

          % ogonkify -N -AT <alamakota.ps | lpr

     or eventually

          % ogonkify -N -CT <alamakota.ps | lpr

     Change the -N option to -M if you use Mosaic.


BUGS
     The  composite  character  data  used  is  not  very   good.
     Diacritical marks are often not quite aligned.  Furthermore,
     characters with  an  `ogonek'  should  be  constructed  dif-
     ferently (for instance, the `ogonek' used with an `a' should
     be differently shaped than the one used with an `e'.)

     This program should not be needed were it not for a  bug  in



McKornik Jr.        Last change: 19 Feb 1997                    3






OGONKIFY(1)               User Commands               OGONKIFY(1)



     Netscape.   Obviously, they will neither correct it nor give
     us the sources.

     It would be  better  to  patch  Mosaic  than  to  use  post-
     processing.


NOTES
     In order to view the output PostScript with Ghostscript, you
     might need to run gs with the flag -dNOPLATFONTS, and ghost-
     view with the flag -arguments -dNOPLATFONTS.

     Netscape, IBM, Adobe and PostScript  are  registered  trade-
     marks.


THANKS
     Primoz Peterlin provided the composite  character  data  for
     most  Slavic  languages  other  than Polish.  H. Turgut Uyar
     added the Turkish characters, Ricardas Cepas the  Lithuanian
     ones, and Kristof Petrovay added some support for Hungarian.

     Markku Rossi <mtr@iki.fi> wrote genscript and provided  many
     useful encoding vectors with the distribution.

     Throughout  writing  the  Postscript  code,   I   used   the
     ghostscript interpreter, by Peter Deutsch.

     Larry Wall wrote perl, the syntax and semantics of which are
     a never ending source of puzzlement.



AUTHORS
     Juliusz Chroboczek <jec@dcs.ed.ac.uk>, with help from Primoz
     Peterlin, H. Turgut Uyar and Ricardas Cepas.



















McKornik Jr.        Last change: 19 Feb 1997                    4



