
#ifndef _COOL_ICON_H
#define _COOL_ICON_H

#include <X11/xpm.h>
#include <X11/extensions/shape.h>

typedef struct icon_struct {
    CWidget *w;
    Pixmap mask, picture;
    XpmAttributes attributes;
    char *xpm_filename;		/* the name of the .xpm picture file */
    char *title;		/* the text below the picture */
} CIcon;

CWidget *CDrawIcon (const char *identifier, Window parent, int x, int y, const char *filename, char *title);

/* hooked onto CWidget->user */
typedef struct power_icon_struct {
    char *title;		/* discription below the picture */
    char *xpm_filename;		/* xpm file */
    int x, y;			/* positions */
    char *prompt;		/* prompt for to enter a string to pass to the 
				   script or NULL */
    char *confirm;		/* prompt message for confirmation or NULL */
    int options;
    char *drop_script;		/* script to run on recieving a drop */
    char *double_click_script;	/* script to run on recieving a double click */
    char *tool_hint;
} CPowerIcon;

#define ICON_OPTION_CONFIRM_DOUBLE_CLICK	(1<<0)
#define ICON_OPTION_PROMPT_DOUBLE_CLICK		(1<<1)
#define ICON_OPTION_CONFIRM_DROP		(1<<2)
#define ICON_OPTION_PROMPT_DROP			(1<<3)

#endif

