#ifndef _MOUSE_MARK
#define _MOUSE_MARK

/* mouse_mark.h */

void mouse_mark (
    void  *data,			/* generic structure */
    XEvent * event,			/* XEvent */
    CEvent * ce,			/* CWEvent */
    void (*xy) (int, int, int *, int *),
					/* (row, pixel-x-pos) from click pos (x,y) */
    long (*cp) (void *, int, int),	/* get buffer offset from (row, pixel-x-pos) */
    int (*marks) (void *, long *, long *),
					/* get mark start and end */
    int (*range) (void *, long, long, long),
					/* is click between marks? */
    void (*fin_mark) (void *),		/* set marks to not-moving mode (optional) */
    void (*move_mark) (void *),		/* set marks to moving mode (optional) */
    void (*release_mark) (void *, XEvent *),
					/* set marks when button is release.
					   possibly sets selection owner (could be
					   same as fin_mark) (optional) */
    char * (*get_block) (void *, long, long, int *, int *),
					/* return block from between marks,
					   result is free'd by mouse_mark
					   int *, int * is Dnd type, length */
    void (*move) (void *, long, int),	/* move cursor, int is row if needed */
    void (*motion) (void *, long),	/* move second mark position */
    void (*dclick) (void *, XEvent *),	/* called on double click (optional) */
    void (*redraw) (void *, long)	/* called before exit, passing mouse
					   pos in buffer (optional) */
);

#endif
